-- This is the only explatation I've found.
-- stackoverflow.com/questions/7363516/how-to-formulate-an-array-literal-of-a-composite-type-containing-arrays

create type rt as (n numeric, s text, t timestamp, b boolean);
create table t(k serial primary key, r rt[]);

do $body$
declare
  r1 rt;
  r2 rt;
  a rt[];
begin
  r1.n = 42.17;
  r1.s = 'dog';
  r1.t = '2020-02-17 20:55';
  r1.b = true;
  raise info '%', r1::text;

  r2.n = 19.13;
  r2.s = '"Hello", she\he'||chr(10)||'(said | is saying).';
  r2.t = '2019-07-21 16:47';
  r2.b = false;
  raise info '%', r2::text;

  a := array[r1, r2];
  raise info '%', a::text;
end;
$body$;

delete from t;
insert into t(r) values('{

  "(42.17,dog,\"2020-02-17 20:55:00\",t)",
  "(19.13,\"\"\"Hello\"\", she\\\\he
(said | is saying).\",\"2019-07-21 16:47:00\",f)"

}');

select
  (r[1]).n as n,
  (r[1]).s as s,
  (r[1]).t as t,
  (r[1]).b as b
from t where k = 1;


select
  (r[2]).n as n,
  (r[2]).s as s,
  (r[2]).t as t,
  (r[2]).b as b
from t where k = 1;


